create or replace PROCEDURE CCH_EXPORTA_TI_SAP(P_FILIAL    IN VARCHAR2,
                                               P_DTPOSICAO IN DATE,
                                               P_TCDFILIAL IN VARCHAR2)
IS
   V_FILIAL       VARCHAR2(4);
   V_IDINTERFACE  NUMBER;
   V_SEQUENCIAL   NUMBER;
   V_DTCONTABIL   DATE;
   V_MESCONTABIL  VARCHAR2(2);
   V_MENSAGEMERRO VARCHAR2(5000);

   CURSOR C_FILIAL IS SELECT CDFILIAL
                        FROM FILIAL
                       WHERE ((INSTR(P_FILIAL, '_' || CDFILIAL || '_') > 0) OR (P_TCDFILIAL = 'T'))
                       ORDER BY CDFILIAL;
BEGIN
    V_DTCONTABIL  := LAST_DAY(P_DTPOSICAO);
    V_MESCONTABIL := NULL;

    SELECT CASE TO_CHAR(V_DTCONTABIL, 'MM') WHEN '01' THEN '04'
                                       WHEN '02' THEN '05'
                                       WHEN '03' THEN '06'
                                       WHEN '04' THEN '07'
                                       WHEN '05' THEN '08'
                                       WHEN '06' THEN '09'
                                       WHEN '07' THEN '10'
                                       WHEN '08' THEN '11'
                                       WHEN '09' THEN '12'
                                       WHEN '10' THEN '01'
                                       WHEN '11' THEN '02'
                                       ELSE '03'
           END AS MES_CONTABIL
      INTO V_MESCONTABIL
      FROM PARAMGERAL
     WHERE CDPARGERAL = '0001';

   /* Cursor da filial */
   OPEN C_FILIAL;
   LOOP
      /* Grava as variaveis de filial e funcao da filial */
      FETCH C_FILIAL INTO V_FILIAL;
      EXIT WHEN C_FILIAL%NOTFOUND;

      V_IDINTERFACE := USR_CCH_IDINT_INVE.NEXTVAL;
      V_SEQUENCIAL  := 1;

      BEGIN
         FOR C_EXPORTACAOTI IN (SELECT H.CDEXFILIAL AS CECO, F.CDCENTCUST AS CELOG,
                                       SUBSTR(G.CDEMPINTEGRACAO, 1, 4) AS CDEMPINTEGRACAO,
                                       SUBSTR(C.CDCONTREDU, 1, 10) AS CTA_MAYOR1,
                                       SUBSTR(D.CDCONTREDU, 1, 10) AS CTA_MAYOR2,
                                       A.FAMILIA,
                                       ROUND(SUM(A.VRESTOQDIA),0) AS VRESTOQDIA
                                  FROM CONTCTBL C, CONTCTBL D, FILIAL F, PARAMEMPRESA G, PARAMFILIAL H,
                                       (SELECT B.CDFILIAL,
                                               B.CDPRODUTO,
                                               CCH_CTBL_PRODUTO(P.CDPRODUTO, 'E') AS CTA_MAYOR1,
                                               CCH_CTBL_PRODUTO(P.CDPRODUTO, 'S') AS CTA_MAYOR2,
                                               CCH_CTBL_PRODUTO(P.CDPRODUTO, 'N') AS FAMILIA,
                                               (NVL(CUSTO_PRODUTO_LCEST(B.CDFILIAL, B.CDPRODUTO, (SELECT NVL(TO_NUMBER(CDTIPCUSTEST),3) FROM PARAMFILIAL WHERE CDFILIAL = B.CDFILIAL),
                                                                        B.DTPOSIESTQ - 1, SYSDATE, B.CDALMOXARIFE, B.CDLOCALESTOQ, B.NRLOTEESTQ, B.NRSUBLOTE),0) * QTESTOQDIA) AS  VRESTOQDIA
                                          FROM POSESTDIA B, PRODUTO P
                                         WHERE B.CDFILIAL      = V_FILIAL
                                           AND ABS(B.QTESTOQDIA) > 0.00001
                                           AND P.CDPRODUTO = B.CDPRODUTO
                                           AND B.DTPOSIESTQ = (SELECT MAX(P.DTPOSIESTQ)
                                                                 FROM POSESTDIA P
                                                                WHERE P.CDFILIAL     = B.CDFILIAL
                                                                  AND P.CDPRODUTO    = B.CDPRODUTO
                                                                  AND P.CDALMOXARIFE = B.CDALMOXARIFE
                                                                  AND P.CDLOCALESTOQ = B.CDLOCALESTOQ
                                                                  AND P.NRLOTEESTQ   = B.NRLOTEESTQ
                                                                  AND P.NRSUBLOTE    = B.NRSUBLOTE
                                                                  AND P.DTPOSIESTQ   <= (TO_DATE(V_DTCONTABIL) + 1))) A
                                 WHERE C.CDCONTCTBL = A.CTA_MAYOR1
                                   AND D.CDCONTCTBL = A.CTA_MAYOR2
                                   AND F.CDFILIAL   = A.CDFILIAL
                                   AND G.CDEMPRESA  = F.CDEMPRESA
                                   AND H.CDFILIAL   = A.CDFILIAL
                                 GROUP BY H.CDEXFILIAL, F.CDCENTCUST,
                                          SUBSTR(G.CDEMPINTEGRACAO, 1, 4),
                                          SUBSTR(C.CDCONTREDU, 1, 10),
                                          SUBSTR(D.CDCONTREDU, 1, 10),
                                          A.FAMILIA)
         LOOP
            INSERT INTO USR_SAP_EXPORTACAOTI
               (CECO, CEBE, CDEMPINTEGRACAO, LEDGER, DTDOCENT, DTCONTABILTI, CLASEDOC, CLASE_MONEDA,
                TIPO_CAMBIO, NRO_REFENCIA, TEXT_CABECERA, CLAVE_CONT1, CTA_MAYOR1, CLAVE_CONT2, CTA_MAYOR2,
                NRO_ASIGNACION, TEXT_POSICION, IMPORTE,
                IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO)
            VALUES
               (C_EXPORTACAOTI.CECO, C_EXPORTACAOTI.CECO, C_EXPORTACAOTI.CDEMPINTEGRACAO, NULL, TO_CHAR(SYSDATE, 'YYYYMMDD'), TO_CHAR(V_DTCONTABIL, 'YYYYMMDD'), 'IF', 'CLP',
                NULL, V_IDINTERFACE, 'INV P' || V_MESCONTABIL || ' ' || C_EXPORTACAOTI.CELOG, '40', C_EXPORTACAOTI.CTA_MAYOR1, '50', C_EXPORTACAOTI.CTA_MAYOR2,
                LPAD(TO_CHAR(TO_NUMBER(V_SEQUENCIAL) * 10), 4, '0'), 'INV P' || V_MESCONTABIL || ' ' || C_EXPORTACAOTI.CELOG || ' ' || C_EXPORTACAOTI.FAMILIA, C_EXPORTACAOTI.VRESTOQDIA,
                USR_CCH_IDINT_INVG.NEXTVAL, 'I', SYSDATE, NULL, 0, 1, 2);

            V_SEQUENCIAL := V_SEQUENCIAL + 1;
         END LOOP;
         COMMIT;
      EXCEPTION
         WHEN OTHERS THEN BEGIN
            V_MENSAGEMERRO := SQLERRM(SQLCODE);
            ROLLBACK;

            INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
            VALUES(V_IDINTERFACE, 'I', 8, SYSDATE, 1, V_FILIAL || ' ' || V_MESCONTABIL || ' - ' || SUBSTR(V_MENSAGEMERRO,1,1963));

            COMMIT;
         END;
      END;
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CCH_EXPORTA_TI_SAP','6.49.077'); END;
/
