/* Sistemas Integrados TEKNISA
  Integrao ONBOS

Nome: 0007_LSGSTRO_ONBOS.SQL

Descrio:
Criao das tabelas especficas para gerao de nota fiscal a partir do OnBos

@C:\web_550\sql\end_conv\oracle\clientes\lsg\0007_LSGSTRO_ONBOS.SQL

Criao:
18/01/2012 - Fabrcio Marcelo da Silva
*/


ALTER TABLE FILIAL ADD USR_CDFILIONBOS VARCHAR2(03) NULL
/

ALTER TABLE FILIAL ADD USR_CDCLIECATER VARCHAR2(21) NULL
/

ALTER TABLE PARAMGERAL ADD USR_CDTPOPONBOS VARCHAR2(02) NULL
/

ALTER TABLE NOTAFISCAL ADD USR_CDBARSET VARCHAR2(05) NULL
/

ALTER TABLE NOTAFISCAL ADD USR_SITUNFONBOS VARCHAR2(01) NULL
/

CREATE TABLE TMP_ING_ONBOSTEKNF
(
   CDPIDSEQ		      VARCHAR2(20)	NOT NULL,
   CDFILIORIG		   VARCHAR2(04)	NOT NULL,
   CDFILIDEST		   VARCHAR2(04)	NOT NULL,
   CLIEFISICO		   VARCHAR2(11)	NULL,
   CLIEJURIDI		   VARCHAR2(14)	NULL,
   CLIEPADRAO		   VARCHAR2(14)	NULL,
   CDCLIENTE		   VARCHAR2(14)	NOT NULL,
   DADOSADDNF		   VARCHAR2(40)	NULL,
   CDSERIEBOS		   VARCHAR2(03)	NOT NULL,
   NRNOTABOS		   VARCHAR2(09)	NOT NULL,
   DTSAIDABOS		   DATE	       	NOT NULL,
   DTEMISSBOS		   DATE		      NOT NULL,
   CDCHAVACES	     	VARCHAR2(44)	NULL,
   IDSITUNF		      VARCHAR2(01)	NULL,
   CDBARSET		      VARCHAR2(05)	NULL,
   IDIMPCANCINTEGRA  VARCHAR2(01)   NULL,
   CONSTRAINT PK_ONBOSTEKNF PRIMARY KEY (CDPIDSEQ)
)
/

CREATE TABLE TMP_ING_ONBOSTEKIT
(
   CDPIDSEQ	    	VARCHAR2(20)	NOT NULL,
   CDSEQITEM		VARCHAR2(04)	NOT NULL,
   CDPRODUTO		VARCHAR2(10)	NOT NULL,
   CDPRODEMIS		VARCHAR(20)  	NOT NULL,
   QTDEPRODBOS		NUMBER	   	NOT NULL,
   VRUNITBOS		NUMBER	    	NOT NULL,
   VRDESCBOS		NUMBER	   	NULL,
   CONSTRAINT PK_ONBOSTEKIT PRIMARY KEY (CDPIDSEQ, CDSEQITEM)
)
/

CREATE TABLE TMP_ING_ONBOSTEKLG
(
   CDPIDSEQ		VARCHAR2(20)	NOT NULL,
   DSERRO	   VARCHAR2(2000)	NOT NULL,
   CONSTRAINT PK_ONBOSTEKLG PRIMARY KEY (CDPIDSEQ)
)
/

CREATE TABLE DADOSIMPONBOS
(
   CDFILIAL		   VARCHAR2(04)    NOT NULL,
   NRLANCTONF    	VARCHAR2(10)    NOT NULL,
   CDCLIEFISICO	VARCHAR2(11)    NULL,
   CDCLIEJURIDI	VARCHAR2(14)    NULL,
   CDCLIEPADRAO	VARCHAR2(14)    NULL,
   SGONBOS      	VARCHAR2(02)    NOT NULL,
   NMCOMPAN       VARCHAR2(20)	 NOT NULL,
   NRVOOBOS	      VARCHAR2(04)	 NOT NULL,
   IDSITUNF	      VARCHAR2(01)    DEFAULT 'E' NOT NULL
      CONSTRAINT CKC_IDSITUNF_DADOSIMP CHECK (IDSITUNF IN ('C','E')),
   CONSTRAINT PK_DADOSIMPONBOS PRIMARY KEY (CDFILIAL, NRLANCTONF)
)
/

ALTER TABLE DADOSIMPONBOS MODIFY SGONBOS NULL
/

ALTER TABLE DADOSIMPONBOS MODIFY NMCOMPAN NULL
/

ALTER TABLE DADOSIMPONBOS MODIFY NRVOOBOS NULL
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZACAO_ESTRUTURA_BD','5.50.XXX'); END;
/
