CREATE OR REPLACE TRIGGER LOG_GOP_PERCDETPRODFILGOP
AFTER UPDATE OR INSERT
ON PERCDETPRODFILGOP FOR EACH ROW
DECLARE
   V_TIPO                    VARCHAR2(1);
   V_DSREMOTEADDR            VARCHAR2(15);
   V_DSREMOTEHOST            VARCHAR2(15);
   V_DSSERVERRDM             VARCHAR2(100);
   V_DSSERVMETHOD            VARCHAR2(4000);
   V_DSREMOTEOPER            VARCHAR2(12);
   V_DESC                    VARCHAR2(4000);
   V_CDFILLOGOPER            VARCHAR2(4);
   V_ITPESQ                  VARCHAR2(40);
   V_NMOPERADOR              VARCHAR2(40);
   V_CDOPERADOR              VARCHAR2(12);
   V_NMTABELA                VARCHAR2(20);
   V_DESCUPD                 VARCHAR2(4000);

   V_NMFILIAL                VARCHAR2(100);

   V_IDDESPPREV              VARCHAR2(100);
   V_CDDESPPREV              VARCHAR2(100);
   V_NMDESPPREV              VARCHAR2(100);
   V_CDPRODUTO               VARCHAR2(100);
   V_CDARVPROD               VARCHAR2(100);
   V_NMPRODUTO               VARCHAR2(100);
   V_UNIDADE                 VARCHAR2(50);
   V_CDSERVFILI              VARCHAR2(05);
   V_NMSERVICO               VARCHAR2(40);
   V_CDFATUDIVER             VARCHAR2(02);
   V_DSFATUDIVER             VARCHAR2(40);
   V_CDIMPOSTO               VARCHAR2(02);
   V_NMIMPOSTO               VARCHAR2(50);
   V_CDSUBGRPROD             VARCHAR2(10);
   V_NMSUBGRPROD             VARCHAR2(40);
   V_CDINVEST                VARCHAR2(10);
   V_NMINVEST                VARCHAR2(50);   
   V_CDTIPOOPER              VARCHAR2(02);
   V_NMTIPOOPER              VARCHAR2(30);
   V_CDTPCTPAGAR             VARCHAR2(06);
   V_DSTPCTPAGAR             VARCHAR2(40);
   V_CDCONTCTBL              VARCHAR2(20);
   V_NMCONTCTBL              VARCHAR2(60);
   
   V_CDORCAMENTOMO           VARCHAR2(100);
   V_DSORCAMENTOMO           VARCHAR2(100);
   V_DSDESPADMFAT            VARCHAR2(100);
   
   V_NRSEQITEMORCA           NUMBER;
   
   PROCEDURE NMOPERADOR (P_CDOPERADOR IN OUT VARCHAR2,
                         P_NMOPERADOR OUT VARCHAR2) AS
   BEGIN
     P_NMOPERADOR := NULL;
     BEGIN
        SELECT CDOPERADOR, NMOPERADOR
          INTO P_CDOPERADOR, P_NMOPERADOR
          FROM OPERADOR
         WHERE CDOPERADOR = P_CDOPERADOR;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
          P_CDOPERADOR := 'VIA BD';
          P_NMOPERADOR := 'VIA BD';
     END;
  END;

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_TIPO         := '';
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_CDOPERADOR   := '';
   V_CDFILLOGOPER := '';
   V_NMTABELA     := 'PERCDETPRODFILGOP';

   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
    
   V_DSSERVERRDM := 'gop21000_percentual_por_item_operacional';           
   V_DESCUPD      := 'Percentual por Item Operacional' || chr(10) || '-> Unidade ';

   IF TO_CHAR(:NEW.CDFILIAL) = 'T' OR TO_CHAR(:NEW.CDFILIAL) =  'P' THEN
      V_UNIDADE := 'Unidade: Padro' || chr(10);
   ELSE
      SELECT MAX(NMFILIAL) INTO V_NMFILIAL FROM FILIAL WHERE CDFILIAL = :NEW.CDFILIAL;
       V_UNIDADE := 'Unidade: '|| :NEW.CDFILIAL || ' - ' || V_NMFILIAL || chr(10);
   END IF;
   
   SELECT MAX(P.NRSEQITEMORCA)
     INTO V_NRSEQITEMORCA
     FROM PERCITDETALFILGOP PD INNER JOIN PERCITFILGOP P ON P.NRPERCITFILGOP = PD.NRPERCITFILGOP
    WHERE NRPERCITDETALFILGOP = :NEW.NRPERCITDETALFILGOP;
    
   IF V_NRSEQITEMORCA = 0 THEN
      V_DESCUPD := V_DESCUPD || '-> Faturamento -> Detalhamento';
   ELSIF V_NRSEQITEMORCA = 1 THEN
      V_DESCUPD := V_DESCUPD || '-> Imposto -> Detalhamento';
   ELSIF V_NRSEQITEMORCA = 2 THEN
      V_DESCUPD := V_DESCUPD || '-> Consumo -> Detalhamento';
   ELSIF V_NRSEQITEMORCA = 3 THEN
      V_DESCUPD := V_DESCUPD || '-> Mo de Obra -> Detalhamento';
   ELSIF V_NRSEQITEMORCA = 5 THEN
      V_DESCUPD := V_DESCUPD || '-> Despesas da Matriz -> Detalhamento';
   ELSIF V_NRSEQITEMORCA = 6 THEN
      V_DESCUPD := V_DESCUPD || '-> Despesas Diversas -> Detalhamento';
   ELSIF V_NRSEQITEMORCA = 7 THEN
      V_DESCUPD := V_DESCUPD || '-> Despesas Lanc. Entrada -> Detalhamento';
   ELSIF V_NRSEQITEMORCA = 8 THEN
      V_DESCUPD := V_DESCUPD || '-> Imposto a Recuperar -> Detalhamento';
   ELSIF V_NRSEQITEMORCA = 9 THEN
      V_DESCUPD := V_DESCUPD || '-> Impostos Sobre o Lucro -> Detalhamento';
   ELSIF V_NRSEQITEMORCA = 10 THEN
      V_DESCUPD := V_DESCUPD || '-> Investimento -> Detalhamento';
   END IF;
   IF :NEW.CDPRODUTO IS NOT NULL THEN
      SELECT MAX(PDG.IDDESPPREV), MAX(PR.CDDESPPREV), MAX(D.NMDESPPREV),
             MAX(PR.CDPRODUTO),MAX(P.CDARVPROD), MAX(P.NMPRODUTO)
        INTO V_IDDESPPREV, V_CDDESPPREV, V_NMDESPPREV, V_CDPRODUTO, V_CDARVPROD, V_NMPRODUTO
        FROM DESPPREV D JOIN PRODDESPPREV PR ON D.CDDESPPREV = PR.CDDESPPREV 
                        JOIN PRODUTO P ON PR.CDPRODUTO = P.CDPRODUTO 
                        LEFT JOIN PERCITDETALFILGOP PDG ON PDG.NRPERCITDETALFILGOP = :NEW.NRPERCITDETALFILGOP 
                                                       AND PDG.CDDESPPREV = D.CDDESPPREV 
                                                       AND PDG.CDFILIAL = :NEW.CDFILIAL
       WHERE D.CDDESPPREV = PR.CDDESPPREV
         AND PR.CDPRODUTO = :NEW.CDPRODUTO;
   
      IF V_CDPRODUTO IS NULL THEN
         SELECT MAX(CDPRODUTO), MAX(CDARVPROD), MAX(NMPRODUTO)
           INTO V_CDPRODUTO, V_CDARVPROD, V_NMPRODUTO
           FROM PRODUTO
          WHERE CDPRODUTO = :NEW.CDPRODUTO;
          
         V_DESC := chr(10) || chr(10) || V_UNIDADE || 'Produto: ' || V_CDARVPROD || ' - ' || V_NMPRODUTO || chr(10);
      ELSE
          V_DESC := chr(10) || chr(10) || V_UNIDADE || 'Despesa: ' || V_CDDESPPREV || ' - ' || V_NMDESPPREV || chr(10) ||
                   'Produto: ' || V_CDARVPROD || ' - ' || V_NMPRODUTO || chr(10);
      END IF;
   ELSIF :NEW.CDTPCTPAGAR IS NOT NULL THEN
      SELECT MAX(CDTPCTPAGAR), MAX(DSTPCTPAGAR)
        INTO V_CDTPCTPAGAR, V_DSTPCTPAGAR
        FROM TIPOCTPAGAR
       WHERE CDTPCTPAGAR = :NEW.CDTPCTPAGAR;
         
      IF NVL(:OLD.VRPERCENTUAL, 0) <> NVL(:NEW.VRPERCENTUAL, 0)  THEN   
         IF V_CDTPCTPAGAR IS NOT NULL THEN
            V_DESC := chr(10) || chr(10) || V_UNIDADE || 'Conta a pagar: ' || V_CDTPCTPAGAR || ' - ' || V_DSTPCTPAGAR || chr(10);
         END IF;
      END IF;
   ELSIF :NEW.CDCONTCTBL IS NOT NULL THEN  
      SELECT MAX(CDCONTCTBL), MAX(NMCONTCTBL)
        INTO V_CDCONTCTBL, V_NMCONTCTBL
        FROM CONTCTBL
       WHERE CDCONTCTBL = :NEW.CDCONTCTBL;
         
      IF NVL(:OLD.VRPERCENTUAL, 0) <> NVL(:NEW.VRPERCENTUAL, 0)  THEN   
         IF V_CDCONTCTBL IS NOT NULL THEN
            V_DESC := chr(10) || chr(10) || V_UNIDADE || 'Conta contbil: ' || V_CDCONTCTBL || ' - ' || V_NMCONTCTBL || chr(10);
         END IF;
      END IF;
   ELSIF :NEW.CDTIPOOPER IS NOT NULL THEN
      SELECT MAX(CDTIPOOPER), MAX(NMTIPOOPER)
        INTO V_CDTIPOOPER, V_NMTIPOOPER
        FROM TIPOOPERAC
       WHERE CDTIPOOPER = :NEW.CDTIPOOPER
         AND IDENTRSAIDOP = :NEW.IDENTRSAIDOP;
         
      IF NVL(:OLD.VRPERCENTUAL, 0) <> NVL(:NEW.VRPERCENTUAL, 0)  THEN
         IF V_CDFATUDIVER IS NOT NULL THEN
            V_DESC := chr(10) || chr(10) || V_UNIDADE || 'Tipo de Operao: ' || V_CDTIPOOPER || ' - ' || V_NMTIPOOPER || chr(10);
         END IF;
      END IF;
   ELSE
      SELECT MAX(DO.CDORCAMENTOMO), MAX(O.DSORCAMENTOMO), MAX(DF.DSDESPADMFAT)
        INTO V_CDORCAMENTOMO, V_DSORCAMENTOMO, V_DSDESPADMFAT
        FROM DESPADMFATUR DF JOIN DESPORCAMO DO ON DF.CDDESPADMFAT = DO.CDDESPADMFAT
                             JOIN ORCAMENTOMO O ON DO.CDORCAMENTOMO = O.CDORCAMENTOMO
                             JOIN PERCITDETALFILGOP PDG ON PDG.NRPERCITDETALFILGOP = :NEW.NRPERCITDETALFILGOP
                                                       AND PDG.CDORCAMENTOMO = DO.CDORCAMENTOMO
       WHERE DO.CDORCAMENTOMO = :NEW.CDORCAMENTOMO
         AND DF.CDDESPADMFAT = :NEW.CDDESPADMFAT
         AND PDG.CDFILIALMO = :NEW.CDFILIALMO;
         
      IF NVL(:OLD.VRPERCENTUAL, 0) <> NVL(:NEW.VRPERCENTUAL, 0)  THEN
         IF :NEW.CDDESPADMFAT IS NOT NULL THEN 
                V_DESC := chr(10) || chr(10) || 'Oramento: ' || :NEW.CDORCAMENTOMO || ' - ' || V_DSORCAMENTOMO || chr(10) ||
                          ' - Despesa: ' || :NEW.CDDESPADMFAT || ' - ' || V_DSDESPADMFAT || chr(10);
         END IF;
      END IF;
   END IF;

   IF INSERTING THEN
      V_TIPO         := '1';
      V_ITPESQ       := TO_CHAR(:NEW.NRPERCDETPRODFILGOP);
      V_CDOPERADOR   := :NEW.CDOPERINCLUSAO;

      NMOPERADOR(V_CDOPERADOR, V_NMOPERADOR);

      IF NVL(:OLD.VRPERCENTUAL, 0) <> NVL(:NEW.VRPERCENTUAL, 0)  THEN            
         V_DESC := V_DESC || 
                   'Percentual: ' || NVL(:NEW.VRPERCENTUAL, 0) || '%';
      END IF;        
   ELSIF UPDATING THEN
      V_TIPO := '2';
      V_ITPESQ       := TO_CHAR(:NEW.NRPERCDETPRODFILGOP);
      V_CDOPERADOR   := :NEW.CDOPERULTATU;

      NMOPERADOR(V_CDOPERADOR, V_NMOPERADOR);

      IF NVL(:OLD.VRPERCENTUAL, 0) <> NVL(:NEW.VRPERCENTUAL, 0)  THEN
         IF V_IDDESPPREV IS NOT NULL THEN
            V_DESC := V_DESC || 
                      'Percentual alterado de: ' || NVL(:OLD.VRPERCENTUAL, 0) || '% para: '|| NVL(:NEW.VRPERCENTUAL, 0) || '%';
         END IF;
      END IF;
   END IF;

   IF NOT V_DESC IS NULL THEN
     V_DESC := V_DESCUPD || V_DESC;
     INSERT INTO LOGOPERAGES
        (NMTABELA,     DTOPERACAO,   NMRESPOPER,  IDTIPOOPER,   DSOPERACAO,  CDPESQITEM,
         DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
     VALUES
        ('PERCDETPRODFILGOP', SYSDATE, NVL(V_NMOPERADOR,' '), V_TIPO, V_DESC, V_ITPESQ, NVL(V_DSSERVERRDM, ' '), 
          NVL(V_DSREMOTEADDR, ' '), NVL(V_DSREMOTEHOST, ' '), NVL(V_DSSERVMETHOD, ' '), NVL(V_CDOPERADOR, ' '),
          NVL(V_CDFILLOGOPER, ' '));
   END IF;
END;
/
